﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGGroupByCase
{
    public class CustomGroupEvaluator : IGroupByEvaluator
    {
        public bool DoesGroupContainRecord(GroupByRecord groupByRecord, DataRecord record)
        {
            SampleData SD = record.DataItem as SampleData;
            DataRecord dr = groupByRecord.ChildRecords.First() as DataRecord;
            SampleData existingData = dr.DataItem as SampleData;

            if (SD.Date.Month == existingData.Date.Month)
            {
                groupByRecord.Description = SD.Date.Month.ToString() + " (" + groupByRecord.ChildRecords.Count.ToString() + " items)";
                return true;
            }
            else
            {
                return false;
            }
        }        

        public object GetGroupByValue(GroupByRecord groupByRecord, DataRecord record)
        {            
            SampleData sd = record.DataItem as SampleData;            
            return sd.Date.Month;
        }

        public System.Collections.IComparer SortComparer
        {
            get
            {
                return new CustomGroupByComparer();
            }
        }     
    }
}
